// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_common_msgs:msg/ReturnCode.idl
// generated code does not contain a copyright notice

#ifndef RC_COMMON_MSGS__MSG__DETAIL__RETURN_CODE__TRAITS_HPP_
#define RC_COMMON_MSGS__MSG__DETAIL__RETURN_CODE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_common_msgs/msg/detail/return_code__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rc_common_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ReturnCode & msg,
  std::ostream & out)
{
  out << "{";
  // member: value
  {
    out << "value: ";
    rosidl_generator_traits::value_to_yaml(msg.value, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ReturnCode & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "value: ";
    rosidl_generator_traits::value_to_yaml(msg.value, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ReturnCode & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_common_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_common_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_common_msgs::msg::ReturnCode & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_common_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_common_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_common_msgs::msg::ReturnCode & msg)
{
  return rc_common_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_common_msgs::msg::ReturnCode>()
{
  return "rc_common_msgs::msg::ReturnCode";
}

template<>
inline const char * name<rc_common_msgs::msg::ReturnCode>()
{
  return "rc_common_msgs/msg/ReturnCode";
}

template<>
struct has_fixed_size<rc_common_msgs::msg::ReturnCode>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_common_msgs::msg::ReturnCode>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_common_msgs::msg::ReturnCode>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_COMMON_MSGS__MSG__DETAIL__RETURN_CODE__TRAITS_HPP_
